/* Answers/PublishSubscribe/Base/EventLogic/EventLogic.cls  */
/* Copyright 2011-2015 TDK Consulting Services Inc.         */
/* Timothy D. Kuehn - tim.kuehn@gmail.com                   */

CLASS Answers.PublishSubscribe.Base.EventLogic.EventLogic: 

/****************************************************************************/
/* Class Events                         */

DEFINE PRIVATE EVENT DayShift           SIGNATURE VOID ().
DEFINE PRIVATE EVENT NightShift         SIGNATURE VOID ().

/****************************************************************************/
/* Class Variables                      */

DEFINE VARIABLE iCnt                    AS INTEGER NO-UNDO.

DEFINE VARIABLE iStraightPay            AS INTEGER NO-UNDO.
DEFINE VARIABLE iDoublePay              AS INTEGER NO-UNDO.

/****************************************************************************/
METHOD PUBLIC VOID RunHumanExample():
/****************************************************************************/

THIS-OBJECT:DayShift:Subscribe(THIS-OBJECT:StraightPay()).
THIS-OBJECT:NightShift:Subscribe(THIS-OBJECT:DoublePay()).

THIS-OBJECT:ExecuteLogic("Human").

END METHOD.

/****************************************************************************/
METHOD PUBLIC VOID RunVampireExample(): 
/****************************************************************************/

THIS-OBJECT:NightShift:Subscribe(THIS-OBJECT:StraightPay()).
THIS-OBJECT:DayShift:Subscribe(THIS-OBJECT:DoublePay()).

THIS-OBJECT:ExecuteLogic("Vampire").

END METHOD.

/****************************************************************************/
METHOD PRIVATE VOID ExecuteLogic(chMsg AS CHARACTER):
/****************************************************************************/
/* Local Variables                      */

DEFINE VARIABLE iCnt                    AS INTEGER NO-UNDO.

/****************************************************************************/

DO iCnt = 1 TO 10:
    THIS-OBJECT:DayShift:Publish().
END.

DO iCnt = 1 TO 20:
    THIS-OBJECT:NightShift:Publish().
END.    

MESSAGE chMsg                           SKIP 
        "Straight Pay"  iStraightPay    SKIP 
        "Double Pay"    iDoublePay
   VIEW-AS ALERT-BOX.

END METHOD.

/****************************************************************************/
METHOD PRIVATE VOID StraightPay():
/****************************************************************************/
ASSIGN iStraightPay = iStraightPay + 1.
END METHOD.

/****************************************************************************/
METHOD PRIVATE VOID DoublePay():
/****************************************************************************/
ASSIGN iDoublePay = iDoublePay + 2.
END METHOD.

END CLASS.

