/* Answers/PublishSubscribe/Base/Train/RailFan.cls      */
/* Copyright 2011-2015 TDK Consulting Services Inc.     */
/* Timothy D. Kuehn - tim.kuehn@gmail.com               */

CLASS Answers.PublishSubscribe.Base.Train.RailFan: 

DEFINE PUBLIC EVENT TakePicture SIGNATURE VOID ().

/****************************************************************************/
/* Local Variables                      */

    /* Count number of sonds heard      */
    
DEFINE VARIABLE iHeardCount     AS INTEGER      NO-UNDO.    

    /* Code to show the sound and time  */
    
DEFINE VARIABLE chSound         AS CHARACTER    NO-UNDO.
DEFINE VARIABLE dtmSoundHeard   AS DATETIME     NO-UNDO.

DEFINE FRAME fRailFan 
        chSound         FORMAT "X(20)"  COLUMN-LABEL "Event"
        dtmSoundHeard   COLUMN-LABEL "Time Heard"
    WITH TITLE "RailFan"
        OVERLAY 
        DOWN
        WIDTH 70.
        
/****************************************************************************/
/* Display an update when we see something      */

METHOD PUBLIC VOID Watch(chWatch AS CHARACTER):
THIS-OBJECT:ShowMessage(chWatch).
END METHOD.

/****************************************************************************/
/* Report what and when we heard something      */

METHOD PUBLIC VOID Listen(chSoundParm AS CHARACTER):

THIS-OBJECT:ShowMessage(chSoundParm).

    /* Every so often take a picture */
    
ASSIGN 
    iHeardCount= iHeardCount + 1
    .

IF iHeardCount MODULO 10 = 0 THEN 
    THIS-OBJECT:TakePicture:Publish().

END METHOD.

/****************************************************************************/
/* Report what happened                         */

METHOD PRIVATE VOID ShowMessage(chMsg AS CHARACTER):

DISPLAY chMsg @ chSound
        NOW @ dtmSoundHeard
    WITH FRAME fRailFan
        DOWN.    
        
    DOWN 1 
        WITH FRAME fRailFan.

END METHOD.
END CLASS.
